% Lezione TTR  -15/01/2014- Mean Shift for segmentation - Marco Cristani
close all;
clear all;


%% Visualizzazione 3D colore ------------------------------------- %% 
figure;  set(gcf,'name','3D visualizations');
rgb    =  imread('peppers.png');
Rrgb   =  imresize(rgb,0.15,'bicubic');
subplot(3,1,1); imshow(Rrgb)
title('Original')
colori =  double(reshape(Rrgb,size(Rrgb,1)*size(Rrgb,2),3));
subplot(3,1,2); 
scatter3(colori(:,1),colori(:,2),colori(:,3));
xlabel('R'), ylabel('G'), zlabel('B');
title('RGB')
cform  =  makecform('srgb2lab');
Rlab    =  applycform(Rrgb, cform);
colori_LAB =  double(reshape(Rlab,size(Rlab,1)*size(Rlab,2),3));
subplot(3,1,3); 
scatter3(colori_LAB(:,1),colori_LAB(:,2),colori_LAB(:,3));
title('CIELAB')

%% kmeans segmentation (on color)
K = 3; % numero cluster
I = size(Rrgb,1);
J = size(Rrgb,2);
Data = reshape(Rrgb,I*J,3);
Label = kmeans(double(Data),K);
DBscore = DavisBoldwin(Data,Label)
figure; subplot(1,3,1); 
scatter3(Data(:,1),Data(:,2),Data(:,3),10); 
subplot(1,3,2); 
scatter3(Data(:,1),Data(:,2),Data(:,3),10,Label); 
subplot(1,3,3); 
res_image = reshape(Label,I,J);
imagesc(res_image);

%% kmeans segmentation (on coords + color)
% Effettuo la normalizzazione delle feature;
Estremo = max(I,J);
VI = [1:I]';
VJ = [1:J]';
VI = VI.*(255/Estremo);
VJ = VJ.*(255/Estremo);
[X,Y] = Cartesian_product(VI,VJ);
X = X(:);
Y = Y(:);
Data = [X,Y,double(reshape(Rrgb,I*J,3))];
Label = kmeans(double(Data),K);
DBscore = DavisBoldwin(Data,Label)
figure; subplot(1,3,1); 
scatter3(Data(:,3),Data(:,4),Data(:,5),10); 
subplot(1,3,2); 
scatter3(Data(:,3),Data(:,4),Data(:,5),10,Label); 
subplot(1,3,3); 
res_image = reshape(Label,I,J);
imagesc(res_image);
set(gcf,'name','Kmeans on coords and RGB')

%% Visualizzazione risultati
for i=1:K
    figure;
    Et = Label == i; Et = repmat(Et,[1,1,3]);
    Mask = reshape(Et,I,J,3);
    imagesc(uint8(Mask.*double(Rrgb)));
end

%%  MS segmentation
[I,J,C] = size(Rrgb);
Rlab    =  applycform(Rrgb, cform);
Data = [double(reshape(Rlab,I*J,C))];
[clustCent,data2cluster,cluster2dataCell] =...
    MS_Clustering_Speed(Data,20,20);
figure; subplot(1,4,1); 
scatter3(Data(:,1),Data(:,2),Data(:,3),10); 
subplot(1,4,2); 
scatter3(Data(:,1),Data(:,2),Data(:,3),10,data2cluster); 
subplot(1,4,3); 
res_image = reshape(data2cluster,I,J);
imagesc(res_image);
subplot(1,4,4); imshow(rgb);
set(gcf,'name','MS Segmentation on CIELAB');
DBscore = DavisBoldwin(Data,data2cluster)

%% Confrontare con Kmeans segmentation


%%  MS segmentation with spatial info

[X,Y] = Cartesian_product([1:I]',[1:J]');
X = X(:);
Y = Y(:);
Data = [X,Y,double(reshape(Rrgb,I*J,3))];
[Label,C_centers] = MS_Clustering2(Data,[30,30,70,70,70],'Uniform',[2,3],10);
figure;  set(gcf,'name','MS Segmentation on RGB');
subplot(2,1,1); imagesc(reshape(Label,I,J));axis equal; colorbar; 
subplot(2,1,2); imshow(Rrgb);

%%  Comparisons
DBscoreMS = DavisBoldwin(Data,Label); % con MS
Label = kmeans(double(Data),max(Label));
DBscoreKM = DavisBoldwin(Data,Label); % con KM






